object w, gc,d;
object visual, root;
int depth;

int width=250, height=250;
object in_image = 
(Image.PNM.decode( Stdio.read_bytes("/home/per/pics/chateau.ppm") ));
// ->grey()->rgb_to_hsv();

void plot_image_24zbgr(object in, int xp, int yp, object image)
{
  // 32 bit, upper 8 bit unused, then blue green red (mostcommon
  // truecolor format)

  if((image->xsize()*image->ysize()) < 65500)
    in->PutImage(gc, 24,xp,yp, image->xsize(), image->ysize(), image->tozbgr(), 2);
  else 
  {
    // paste whole lines. Sum should be max 65500 ints (max request is 2^16)
    int ys = 65500 / image->xsize();
    int ix = image->xsize();
    object slice;
    for(int y=0; y <= image->ysize()/ys; y++)
    {
      slice = image->copy(0, y*ys, ix-1, y*ys+ys-1);
      in->PutImage( gc, 24, xp, yp+y*ys, ix, ys, slice->tozbgr(),2  );
    }
  }
}

void plot_image_24rgbz(object in, int xp, int yp, object image)
{
  if((image->xsize()*image->ysize()) < 65500)
    in->PutImage(gc, 24,xp,yp, image->xsize(), image->ysize(), image->torgb(),2);
  else 
  {
    // paste whole lines. Sum should be max 65500 ints (max request is 2^16)
    int ys = 65500 / image->xsize();
    int ix = image->xsize();
    object slice;
    for(int y=0; y <= image->ysize()/ys; y++)
    {
      slice = image->copy(0, y*ys, ix-1, y*ys+ys-1);
      in->PutImage( gc, 24, xp, yp+y*ys, ix, ys, slice->torgb(),1 );
    }
  }
}

object greytable;

void plot_image_8grey(object in, int xp, int yp, object image)
{
  if (image->xsize()%4) // 32 bit offsets.
  {
    werror("WARNING: plotting non-aligned image!\n");
    image = image->copy(0,0,(image->xsize()/4+1)*4-1, image->ysize()-1);
  }
  if(!greytable)
  {
    greytable = Image.colortable( 0,0,0, ({0,0,0}), ({255,255,255}), 256 );
  }
  if((image->xsize()*image->ysize()) < (65500*4))
    in->PutImage(gc, 8,xp,yp, image->xsize(), image->ysize(), 
		 image->to8bit( greytable ),1);
  else 
  {
    int ys = (65500*4) / image->xsize();
    int ix = image->xsize();
    object slice;
    for(int y=0; y <= image->ysize()/ys; y++)
    {
      slice = image->copy(0, y*ys, ix-1, y*ys+ys-1);
      in->PutImage( gc, 8, xp, yp+y*ys, ix, ys, slice->to8bit( greytable ),1 );
    }
  }
}

object truetable;

void plot_image_8true(object in, int xp, int yp, object image)
{
  if (image->xsize()%4) // 32 bit offsets.
  {
    werror("WARNING: plotting non-aligned image!\nPadding with black pixels\n");
    image = image->copy(0,0,(image->xsize()/4+1)*4-1, image->ysize()-1);
  }

  if(!truetable)
  {
    array res = allocate(256);
    for(int r=0;r<7; r++)
      for(int g=0;g<7;g++)
	for(int b=0;b<4;b++)
	  res[ r + (g<<3) + (b<<6) ] = ({ (255/6)*r,(254/6)*g,(255/3)*b });

    res = replace(res, 0, ({ 255,255,255 }));
    truetable = Image.colortable( res );
    truetable->ordered();
  }
  
  if((image->xsize()*image->ysize()) < (65500*4))
    in->PutImage(gc, 8,xp,yp, image->xsize(), image->ysize(), 
		 image->to8bit( truetable ),1);
  else 
  {
    int ys = (65500*4) / image->xsize();
    int ix = image->xsize();
    object slice;
    for(int y=0; y <= image->ysize()/ys; y++)
    {
      slice = image->copy(0, y*ys, ix-1, y*ys+ys-1);
      in->PutImage( gc, 8, xp, yp+y*ys, ix, ys, slice->to8bit( truetable ),1 );
    }
  }
}

inline int abs(int X)
{
  if(X<0) return  -X;
  return X;
}
  
int find_nearest_color(array c, array in)
{
  int best, best_closeness = 2000000, cv;
  foreach(in, mapping c)
    if(c)
      if((cv=abs(c[0]-c->red)+ abs(c[1]-c->green)+ abs(c[2]-c->blue)) <= best_closeness)
      {
	best_closeness = cv;
	best = c->pixel;
      }
  return best;
}

#define NUMR 5
#define NUMG 6
#define NUMB 5

// array (int) gamma( array (int) c )
// {
//   float g = 1.0/master()->resolv("XImage")->global_vars["gamma"];
//   int i;
//   for(i=0; i<sizeof(c); i++)
//   {
//     float v = pow((float)(c[i]/65535.0),g);
//     if(v>1.0) v = 1.0;
//     c[i] =(int)(v*65535);
//   }
//   return c;
// }

string allocate_colorcube(object colormap)
{
  array allocated_colors = allocate(256);
  int r, g, b,index;
  int rv,gv,bv;
  string res="";

  for(b=0; b<NUMB; b+=1) for(g=0; g<NUMG; g+=1) for(r=0; r<NUMR; r+=1)
  {
    if(r==NUMR-1) rv=65535; else rv=((256*r*257)/(NUMR-1));
    if(g==NUMG-1) gv=65535; else gv=((256*g*257)/(NUMG-1));
    if(b==NUMB-1) bv=65535; else bv=((256*b*257)/(NUMB-1));
    allocated_colors[(1*r)+(NUMR*g)+(NUMR*NUMG*b)]=
      colormap->AllocColor(rv,gv,bv);
  }

  int alloc;
  for(b=0; b<NUMB; b++)  for(g=0; g<NUMG; g++) for(r=0; r<NUMR; r++)
  {
    index = 1*r + NUMR*g + NUMR*NUMG*b;
    if(allocated_colors[index])
    {
      alloc++;
      res += sprintf("%c", allocated_colors[index]->pixel);
    }
    else
    {
      int rr = ((255*r)/(NUMR-1));
      int gg = ((255*g)/(NUMG-1));
      int bb = ((255*b)/(NUMB-1));
      array color = ({ rr*257, gg*257, bb*257 });
      res += sprintf("%c", find_nearest_color(color,allocated_colors));
    }	    
  }
  return res;
}


mapping pseudo_color_tables = ([ ]);

void plot_image_8pseudo(object in, int xp, int yp, object image, object c)
{
  object ct;

  int ow = image->xsize();
  if (image->xsize()%4) // 32 bit offsets.
  {
    image = image->copy(0,0,(image->xsize()/4+1)*4-1, image->ysize()-1);
  }

  if(!(ct = pseudo_color_tables[in]))
  {
    object c;
    // Allocate X colors (128?) to do the dithering.
    
    if(in->colortable)
      c = in->colortable;
    else
    {
      object p = in;
      while(p = p->parent) c=p;
      // Now we have the root window..
      if(!c)
      {
	werror("Failed to find colormap for drawable!"
	       "Unable to do 24->8bit conversion\n");
	return;
      }
      if(!(c=c->defaultColorMap))
      {
	werror("No default colormap in root window!\n"
	       "Unable to do 24->8bit conversion");
	return;
      }
    }
    // now allocate the colors.
    array wanted = image->select_colors( 100 );

    array got = Array.map(wanted, lambda(array o,object c) { 
	return c->AllocColor( o[0]*257, o[1]*257, o[2]*257 );
    }, c);
    int max_pixel;

    foreach(got, mapping m) if(m && m->pixel > max_pixel) 
      max_pixel = m->pixel;

    array res = allocate( max_pixel+1 );

    foreach(got, mapping m)
      if(m)
	res[ m->pixel ] = ({ m->red/257, m->green/257, m->blue/257 });
//     werror(sprintf("Allocated colortable: %O", res));

    // What to do with unallocated colors??
    res = replace( res, 0, ({ 255,0,255 }) );
    pseudo_color_tables[in] = ct = Image.colortable( res );
    ct->cubicles(12, 12, 12);
    ct->ordered();
  }

  if((image->xsize()*image->ysize()) < (65500*4))
    in->PutImage(gc, 8,xp,yp, ow, image->ysize(), 
		 image->to8bit( ct ),1);
  else 
  {
    int ys = (65500*4) / image->xsize();
    int ix = image->xsize();
    object slice;
    for(int y=0; y <= image->ysize()/ys; y++)
    {
      slice = image->copy(0, y*ys, ix-1, y*ys+ys-1);
      in->PutImage( gc, 8, xp, yp+y*ys, ow, ys, 
		    slice->to8bit( ct ),1 );
    }
  }
}


mapping fun = ([ ]);

void plot_image(object in, int xp, int yp, object image)
{
  if(fun[in]) 
  {
    fun[in](in,xp,yp,image);
    return;
  }
  if(!depth) {
    object p = in, c;
    while(p = p->parent) c=p;
    depth = c->rootDepth;
  }
  if(depth == 24)
    fun[in] = plot_image_24zbgr;
  else
  {
    werror("visual_class: "+(visual?visual->c_class:1)+"\n");
    switch(visual?visual->c_class:1)
    {
     case 0: fun[in] = plot_image_8grey;   break;
     case 1: fun[in] = plot_image_8pseudo; break;
     case 2: fun[in] = plot_image_8true; break;
     case 3: fun[in] = plot_image_8pseudo; break;
     case 4: fun[in] = plot_image_8true;   break;
    }
  }
  fun[in](in,xp,yp,image,visual);
}

object cimage;
void draw(int x, int y, int wi, int he)
{
  if(!cimage || !wi || !he)
  {
    cimage = in_image->copy(0,0,width-1, height-1);
    plot_image( w, 0, 0, cimage );
  } else {
    cimage = in_image->copy(0,0,width-1, height-1);
    plot_image( w, x, y, cimage->copy(x,y,(wi/4)*4+x-1, he-1+y) );
  }
}

int oy, ox,  wx, wy;
int dy, ddy=1, dx=0;
void do_move()
{
  dy+=ddy;
  mapping cr = (["X":wx-dx,"Y":wy-dy]);
  wx = cr->X;
  wy = cr->Y;
  if(cr->X < 0)  dx=-dx;
  if(cr->Y < 0)  {
    dy=-dy;
    if(abs(dy)<10) {
      ddy=-ddy;
    }
    dy+=ddy;
    wy-=dy;
  }
  if(cr->X > 1000)  dx=-dx;
  if(cr->Y > 800)  {
    dy=-dy;
    if(abs(dy)<10) {
      ddy=-ddy;
    }
    dy+=ddy;
    wy-=dy;
  }
  w->Configure(cr);
   call_out(do_move, 0.05);
}

void shape_window(int moving);
void mouse_click( mapping evnt )
{
  remove_call_out(do_move);
  shape_window( 1 );
  ox = evnt->rootX - wx;
  oy = evnt->rootY - wy;
}

void mouse_move( mapping evnt )
{
  dy=0;
  mapping cr = (["X":evnt->rootX-ox,"Y":evnt->rootY-oy]);
  wx = cr->X;
  wy = cr->Y;
  w->Configure(cr);
}

void mouse_noclick()
{
  shape_window( 0 );
#ifdef BOUNCE
   do_move();
#endif
//   draw(0,0,width,height);
}

void exposed(mixed event)
{
  draw(event->x, event->y, event->width, event->height);
}

array circle(int width, int height)
{
  array shape = ({});
  for(int y=-height/2; y<height/2; y++)
  {
    float x=
      sqrt((float)max((max(width,height)/2*max(width,height)/2)-y*y,0.0));
    shape += ({Types.Rectangle((int)(-x+width/2),(y+height/2),(int)(x*2),1)});
  }
  return shape;
}

void shape_window(int moving)
{
   w->ShapeRectangles( "both", 0, 0, "set", circle(width,height));
// w->ShapeRectangles( "both", 0, 0, "set", Types.Rectangle(0,0,width,height));
  if(moving)
  {
    array shape = ({});
    for(int i=height; i>=0; i-=2 )
    shape += ({ Types.Rectangle(0,i, width,1) });
    w->ShapeRectangles( "both", 0, 0, "subtract", shape );
  }
}

void resized(mixed event)
{
  if(event->width != width || event->height != height)
  {
    width = event->width;
    height = event->height;
    shape_window( 0 );
  }
}

string print_mask(int m)
{
  string s="";
  int f=1;
  for(int i=0; i<32; i++)
  {
    if(m&f) s+= "1"; else s+="0";
    f<<=1;
  }
  return reverse(s);
}

int main(int argc, array argv)
{
  d = Xlib.Display();
  d->open();

  foreach(values((root=d->DefaultRootWindow())->depths), array q)
    foreach(q, object v)
    {
      if(v->id == (int)argv[-1])
      {
	visual = v;
	depth = search(root->depths,q);
	werror("ID:        "+sprintf("0x%x",v->id)+"\n"
	       "class:     "+v->c_class+"\n"
	       "bitsRGB:   "+v->bitsPerRGB+"\n"
	       "colormap:  "+v->colorMapEntries+"\n"
	       "redmask:   "+print_mask(v->redMask)+"\n"
	       "greenmask: "+print_mask(v->greenMask)+"\n"
	       "bluemask:  "+print_mask(v->blueMask)+"\n\n");
      }
    }
  if(!visual)
  {
    werror("Using default visual!\n");
    w = root->CreateWindow(0,0,width,height,0,
			   ([
// 			     "BackPixel":0,
  			     "OverrideRedirect":1,
			     "BackingStore":2,
			     "SaveUnder":1,
			   ]));
  } else 
    w = root->CreateWindow(0,0,width,height,0,
			   ([
			     "Colormap":root->CreateColormap( visual ),
 			     "BackPixel":1,
// Override-redirect does not work with non-default visual unless we
// install the colormap on our own. This is of course possible, but...
// 			     "OverrideRedirect":1
			   ]), visual, depth);
  
  gc = w->CreateGC();
  w->set_event_callback("ConfigureNotify", resized);
  w->set_event_callback("Expose", exposed);
  w->set_event_callback("MapNotify", draw);
  w->set_event_callback("ButtonPress", mouse_click);
  w->set_event_callback("ButtonRelease", mouse_noclick);
  w->set_event_callback("MotionNotify", mouse_move);
  w->SelectInput("StructureNotify", "Exposure", "ButtonPress", "ButtonRelease",
"Button1Motion");

  shape_window( 0 );

  w->Map();
  return -1;
}
  
